USES GUtils;

CONST
  File1      : STRING  = '';
  File2      : STRING  = '';
  Standart   : Boolean = False;

  BUF_MAX    = 65000;
  FSize1     : LongInt = 0;
  FSize2     : LongInt = 0;
  Index      : Word    = 0;
  Readen     : Word    = 0;
  Readen1    : Word    = 0;
  Readen2    : Word    = 0;
  TotalDiff  : LongInt = 0;
  FilePos    : LongInt = 0;
  FileOffset : LongInt = 0;
  MaxOffset  : LongInt = 0;

TYPE
  PBuf       = ^TBuf;
  TBuf       = ARRAY[0..BUF_MAX] OF Byte;

VAR
  Screen     : Text;
  F1,F2      : FILE;
  Buf1,Buf2  : PBuf;


PROCEDURE Error(Str:STRING);
BEGIN
  Writeln(Str);
  Halt;
END;


PROCEDURE OpenFile(VAR FHandle:FILE; FName:STRING);
BEGIN
  Assign(FHandle,FName);
  {$I-}
    Reset(FHandle,1);
  {$I+}
  IF IOResult <> 0 THEN Error('ERROR: Can''t open '+FName);
END;


PROCEDURE PrintDifference(Offset:LongInt; DifLen:Word; Dif_1,Dif_2:PBuf);
CONST BYTES_PER_LINE = 24;
VAR I,R:Word; S1,S2:STRING;
BEGIN
  R := 0;
  S1 := PadRight(DecToHex(Offset),6,'0')+':';
  S2 := Replicate(7,' ');
  FOR I := 1 TO DifLen DO
  BEGIN
    Inc(R);
    IF R = BYTES_PER_LINE+1
      THEN BEGIN
             R := 1;
             S1 := Replicate(7,' ');
             S2 := S1;
           END
      ELSE BEGIN
           END;
    S1 := Concat(S1,' ',DecToHex(Dif_1^[I]));
    S2 := Concat(S2,' ',DecToHex(Dif_2^[I]));
    IF (R = BYTES_PER_LINE) OR (I = DifLen) THEN Writeln(S1,#13#10,S2,#13#10);
  END;
END;

PROCEDURE AdvancedCompare;
VAR Dif1,Dif2:PBuf; DifLength:Word;
BEGIN
  New(Dif1);
  New(Dif2);
  DifLength := 1;
  WHILE Buf1^[Index+1] <> Buf2^[Index+1] DO
  BEGIN
    Dif1^[DifLength] := Buf1^[Index];
    Dif2^[DifLength] := Buf2^[Index];
    Inc(Index);
    Inc(DifLength);
    IF (Index = Readen-1) THEN Break;
  END;
  Dif1^[DifLength] := Buf1^[Index];
  Dif2^[DifLength] := Buf2^[Index];
  Inc(TotalDiff,DifLength);
  PrintDifference(FileOffset,DifLength,Dif1,Dif2);
  Inc(FileOffset,Pred(DifLength));
  Dispose(Dif1);
  Dispose(Dif2);
END;

PROCEDURE StandartCompare;
BEGIN
  Write(PadRight(DecToHex(FileOffset),6,'0')+': ');
  Writeln(DecToHex(Buf1^[Index]),' ',DecToHex(Buf2^[Index]));
  Inc(TotalDiff);
END;

BEGIN
  Assign(Screen,''); Rewrite(Screen);

  Writeln('GF`s ADVANCED FILE COMPARE 1.0');
  ClearAttr(1,WhereY-1,30,WhereY-1,$0E);
  Writeln('Copyright (c) 1998 The GodFader / PZ Crack Team'#13#10);
  ClearAttr(20,WhereY-2,21,WhereY-2,$09);  ClearAttr(30,WhereY-2,31,WhereY-2,$09);
  ClearAttr(22,WhereY-2,24,WhereY-2,$0B);  ClearAttr(28,WhereY-2,29,WhereY-2,$0B);
  ClearAttr(25,WhereY-2,27,WhereY-2,$0F);  ClearAttr(35,WhereY-2,37,WhereY-2,$0F);
  ClearAttr(38,WhereY-2,43,WhereY-2,$0A);  ClearAttr(44,WhereY-2,48,WhereY-2,$0C);

  IF ParamCount < 2 THEN Error('  Usage: AFC file1 file2 [/S]');

  File1 := AdjCase(Upper,ParamStr(1));
  File2 := AdjCase(Upper,ParamStr(2));
  IF AdjCase(Upper,ParamStr(3)) = '/S' THEN Standart := True;

  SetFileMode(denyNone,AccessRead);
  OpenFile(F1,File1); OpenFile(F2,File2);

  FSize1 := FSize(File1);
  FSize2 := FSize(File2);
  MaxOffset := FSize1;
  IF FSize2 < MaxOffset THEN MaxOffset := FSize2;
  Writeln('Comparing ',File1,' with ',File2,' (',FSize1,'/',FSize2,') ',MaxOffset,' bytes',#13#10);

  New(Buf1); New(Buf2);

  REPEAT
    {$I-} BlockRead(F1,Buf1^,SizeOf(Buf1^),Readen1); {$I+}
    IF IOResult <> 0 THEN Error('ERROR: Can''t read from '+File1);
    {$I-} BlockRead(F2,Buf2^,SizeOf(Buf2^),Readen2); {$I+}
    IF IOResult <> 0 THEN Error('ERROR: Can''t read from '+File2);
    Readen := Readen1;
    IF Readen2 < Readen THEN Readen := Readen2;
    Inc(FilePos,Readen);
    FOR Index := 0 TO Readen-1 DO
    BEGIN
      IF Buf1^[Index] <> Buf2^[Index]
        THEN BEGIN
               IF Standart
                 THEN StandartCompare
                 ELSE AdvancedCompare;
             END;
      Inc(FileOffset);
    END;
  UNTIL MaxOffset = FilePos;

  IF Standart THEN Writeln;
  Writeln(TotalDiff,' byte(s) different');

  Dispose(Buf1);
  Dispose(Buf2);

  Close(F1);
  Close(F2);
  Close(Screen);
END.